Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/java/eu/dasish/annotation/backend/Helpers.java
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/java/eu/dasish/annotation/backend/Helpers.java	(revision 4995)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/java/eu/dasish/annotation/backend/Helpers.java	(revision 4997)
@@ -70,5 +70,5 @@
                 + "You are logged in.<br>"
                 + "<h3>Welcome to DASISH Webannotator (DWAN)</h3><br>"
-                + "<a href=\"" + baseUri + "\"> to DWAN's test jsp page</a>"
+                + "<a href=\"" + baseUri + "\"> To DWAN's test jsp page</a>"
                 + "</body>";
         return welcome;
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/resources/spring-config/springSecurity.xml
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/resources/spring-config/springSecurity.xml	(revision 4995)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/resources/spring-config/springSecurity.xml	(revision 4997)
@@ -34,6 +34,11 @@
     <security:http>
         <security:intercept-url pattern="/api/authentication/login" access="ROLE_USER" />
-        <security:http-basic />
-        <security:logout delete-cookies="JSESSIONID"/>
+        <security:form-login 
+            login-page="/loginform.jsp" 
+            default-target-url="/api" 
+            authentication-failure-url="/error.jsp" 
+            username-parameter="username"
+            password-parameter="password" />
+        <security:logout delete-cookies="JSESSIONID"  logout-success-url="/logout.jsp"/>
     </security:http>
     
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/createprincipal.jsp
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/createprincipal.jsp	(revision 4997)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/createprincipal.jsp	(revision 4997)
@@ -0,0 +1,61 @@
+<%--
+    Copyright (C) 2013 DASISH
+
+    This program is free software; you can redistribute it and/or
+    modify it under the terms of the GNU General Public License
+    as published by the Free Software Foundation; either version 2
+    of the License, or (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+--%>
+
+<!DOCTYPE html>
+<html>
+    <head>
+        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+    </head>
+    <body onload='document.createForm.username.focus();'>
+
+        <h3>Create record for non-shibboleth users</h3>
+
+            <div id="create-box">
+                <form name='createForm'
+                      action="api/principals/create" method='POST'>
+
+                    <table>
+                        <tr>
+                            <td>Fill name:</td>
+                            <td><input type='text' name='name' /></td>
+                        </tr>
+                        <tr>
+                            <td>Remote id:</td>
+                            <td><input type='text' name='remoteId' value=''></td>
+                        </tr>
+                        <tr>
+                            <td>Password:</td>
+                            <td><input type='password' name='password' /></td>
+                        </tr>
+                        <tr>
+                            <td>e-mail:</td>
+                            <td><input type='text' name='email' /></td>
+                        </tr>
+                        
+                        <tr>
+                            <td colspan='2'><input name="submit" type="submit"
+                                                   value="submit" /></td>
+                        </tr>
+                    </table>
+
+                </form>
+            </div>
+
+    </body>
+</html>
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/error.jsp
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/error.jsp	(revision 4997)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/error.jsp	(revision 4997)
@@ -0,0 +1,30 @@
+<%--
+    Copyright (C) 2013 DASISH
+
+    This program is free software; you can redistribute it and/or
+    modify it under the terms of the GNU General Public License
+    as published by the Free Software Foundation; either version 2
+    of the License, or (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+--%>
+<%@page contentType="text/html" pageEncoding="UTF-8"%>
+<!DOCTYPE html>
+<html>
+    <head>
+        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+    </head>
+    <body>
+     Authentication error. Check username and password. <br>
+     <a href="index.jsp"> To DWAN's test jsp page.</a><br>
+     <a href="loginform.jsp"> To DWAN's login jsp page.</a>
+    </body>
+</html>
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/index.jsp
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/index.jsp	(revision 4995)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/index.jsp	(revision 4997)
@@ -24,9 +24,12 @@
         <p><a href="https://trac.clarin.eu/wiki/DASISH/SpecificationDocument#RESTAPI">https://trac.clarin.eu/wiki/DASISH/SpecificationDocument#RESTAPI</a></p>
       
-        <br> 
+<!--        <br> 
+        <a href="createprincipal.jsp"> create principal record</a> <br> 
+        <br> -->
         <a href="api/authentication/login"> login  </a> <br> 
          <br> 
         <a href="api/authentication/logout"> logout</a> <br> 
-
+        <br> 
+        
         <b>Test URI-s</b><br>
         <b>All output xml-s are valid w.r.t. the schema</b><br>
@@ -40,7 +43,7 @@
         GET <a href="api/annotations?after=2014-02-04 15:57:58.046908&before=2014-04-06 10:08:16.213186">api/annotations?after=2014-02-04 15:57:58.046908&before=2014-04-06 10:08:16.213186</a> 
         !Comment: What is "namespace" query parameter? Must be implemented and tested <br>
-        GET <a href="api/annotations/00000000-0000-0000-0000-000000000021">api/annotations/00000000-0000-0000-0000-000000000021</a>  </br>
-        GET <a href="api/annotations/00000000-0000-0000-0000-000000000021/targets">api/annotations/00000000-0000-0000-0000-000000000021/targets</a>  </br>
-        GET <a href="api/annotations/00000000-0000-0000-0000-000000000021/permissions">api/annotations/00000000-0000-0000-0000-000000000021/permissions</a><br>
+        GET <a href="api/annotations/00000000-0000-0000-0000-000000000022">api/annotations/00000000-0000-0000-0000-000000000022</a>  </br>
+        GET <a href="api/annotations/00000000-0000-0000-0000-000000000022/targets">api/annotations/00000000-0000-0000-0000-000000000022/targets</a>  </br>
+        GET <a href="api/annotations/00000000-0000-0000-0000-000000000022/permissions">api/annotations/00000000-0000-0000-0000-000000000022/permissions</a><br>
         GET <a href="api/targets/00000000-0000-0000-0000-000000000032">api/targets/00000000-0000-0000-0000-000000000032</a>  <br>
         GET <a href="api/targets/00000000-0000-0000-0000-000000000032/versions">api/targets/00000000-0000-0000-0000-000000000032/versions</a>   <br>
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/loginform.jsp
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/loginform.jsp	(revision 4997)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/loginform.jsp	(revision 4997)
@@ -0,0 +1,52 @@
+<%--
+    Copyright (C) 2013 DASISH
+
+    This program is free software; you can redistribute it and/or
+    modify it under the terms of the GNU General Public License
+    as published by the Free Software Foundation; either version 2
+    of the License, or (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+--%>
+
+<!DOCTYPE html>
+<html>
+    <head>
+        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+    </head>
+    <body onload='document.loginForm.username.focus();'>
+
+        <h3>Login for non-shibboleth users</h3>
+
+            <div id="login-box">
+                <form name='loginForm'
+                      action="j_spring_security_check" method='POST'>
+
+                    <table>
+                        <tr>
+                            <td>User:</td>
+                            <td><input type='text' name='username' value=''></td>
+                        </tr>
+                        <tr>
+                            <td>Password:</td>
+                            <td><input type='password' name='password' /></td>
+                        </tr>
+                        <tr>
+                            <td colspan='2'><input name="submit" type="submit"
+                                                   value="submit" /></td>
+                        </tr>
+                    </table>
+
+                </form>
+            </div>
+
+    </body>
+</html>
Index: DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/logout.jsp
===================================================================
--- DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/logout.jsp	(revision 4997)
+++ DASISH/t5.6/backend/annotator-backend/trunk/annotator-backend/src/main/webapp/logout.jsp	(revision 4997)
@@ -0,0 +1,29 @@
+<%--
+    Copyright (C) 2013 DASISH
+
+    This program is free software; you can redistribute it and/or
+    modify it under the terms of the GNU General Public License
+    as published by the Free Software Foundation; either version 2
+    of the License, or (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+--%>
+<%@page contentType="text/html" pageEncoding="UTF-8"%>
+<!DOCTYPE html>
+<html>
+    <head>
+        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+    </head>
+    <body>
+     You are logged out.<br>
+     <a href="index.jsp"> To DWAN's test jsp page.</a>
+    </body>
+</html>