Index: cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DCSViewer.xml
===================================================================
--- cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DCSViewer.xml	(revision 5273)
+++ cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DCSViewer.xml	(revision 5276)
@@ -69,13 +69,13 @@
       </object>
       <object type="jsx3.gui.Block">
-        <variants jsxoverflow="1"></variants>
+        <variants jsxoverflow="2"></variants>
         <strings jsxname="pane" jsxwidth="100%" jsxheight="100%"></strings>
         <dynamics jsxborder="@Outset"></dynamics>
         <object type="jsx3.gui.Block">
-          <variants jsxoverflow="1"></variants>
+          <variants jsxoverflow="2"></variants>
           <strings jsxname="block" jsxwidth="100%" jsxheight="100%" jsxrelativeposition="1"></strings>
           <object type="jsx3.gui.Matrix">
             <variants jsxpagingmodel="3" jsxselectionmodel="2" jsxxmlbind="1" jsxxmlasync="0" jsxrowsperpanel="25"></variants>
-            <strings jsxname="DataCategorySelectionView" jsxbodyborder="1px solid #dfdfef" jsxheaderborder="1px solid #dfdfef" jsxbgcolor="white" jsxsortpath="name" jsxsorttype="text" jsxsortdirection="ascending" jsxrenderingmodel="shallow" jsxicon="" jsxmenu="_jsx_1_9p_cm"></strings>
+            <strings jsxname="DataCategorySelectionView" jsxbodyborder="1px solid #dfdfef" jsxheaderborder="1px solid #dfdfef" jsxbgcolor="white" jsxsortpath="name" jsxsorttype="text" jsxsortdirection="ascending" jsxrenderingmodel="shallow" jsxicon="" jsxmenu="_jsx_1_2ef_cm"></strings>
             <events jsxselect="this.getAncestorOfName(&quot;DCSViewer&quot;).controller.handleSelect(strRECORDID);" jsxdrop="this.getAncestorOfName(&quot;DCSViewer&quot;).controller.handleDrop(objSOURCE,strDRAGIDS);"></events>
             <xslparameters jsx_rowbg1="#ffffff" jsx_rowbg2="#efefff"></xslparameters>
Index: cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DataCategoryBasket.xml
===================================================================
--- cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DataCategoryBasket.xml	(revision 5273)
+++ cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/DataCategoryBasket.xml	(revision 5276)
@@ -9,5 +9,5 @@
 ]]></onAfterDeserialize>
   <object type="jsx3.gui.Block">
-    <variants jsxrelativeposition="1"></variants>
+    <variants jsxrelativeposition="1" jsxoverflow="2"></variants>
     <strings jsxinstanceof="jsx3.app.Model" jsxname="DataCategoryBasket" jsxwidth="100%" jsxheight="100%"></strings>
     <events jsxdrop=""></events>
Index: cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/ExplorerView.xml
===================================================================
--- cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/ExplorerView.xml	(revision 5273)
+++ cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/ExplorerView.xml	(revision 5276)
@@ -8,5 +8,5 @@
 objExplorer = new org.isocat.gui.Explorer(objJSX);]]></onAfterDeserialize>
   <object type="jsx3.gui.Block">
-    <variants jsxoverflow="1"></variants>
+    <variants jsxoverflow="2"></variants>
     <strings jsxname="ExplorerView" jsxwidth="100%" jsxheight="100%" jsxrelativeposition="1"></strings>
     <object type="jsx3.gui.Splitter">
@@ -32,8 +32,8 @@
           <object type="jsx3.gui.Tab">
             <variants jsxzindex="3" jsxheight="20"></variants>
-            <strings jsxname="tab" jsxtext="overview" jsxbgcolor="#d8d8e5"></strings>
+            <strings jsxname="tab" jsxtext="overview" jsxbgcolor="#e8e8f5"></strings>
             <object type="jsx3.gui.Block">
               <variants jsxoverflow="2" jsxrelativeposition="0" jsxleft="0" jsxtop="0"></variants>
-              <strings jsxname="overview" jsxwidth="100%" jsxheight="100%" jsxdisplay="" jsxvisibility=""></strings>
+              <strings jsxname="overview" jsxwidth="90%" jsxheight="90%" jsxdisplay="" jsxvisibility="visible"></strings>
               <dynamics jsxbgcolor="@Solid Medium"></dynamics>
             </object>
@@ -41,8 +41,8 @@
           <object type="jsx3.gui.Tab">
             <variants jsxzindex="3" jsxheight="18"></variants>
-            <strings jsxname="tab" jsxtext="detail" jsxbgcolor="#e8e8f5"></strings>
+            <strings jsxname="tab" jsxtext="detail" jsxbgcolor="#d8d8e5"></strings>
             <object type="jsx3.gui.Block">
               <variants jsxoverflow="2" jsxrelativeposition="0" jsxleft="0" jsxtop="0" jsxloadtype="4"></variants>
-              <strings jsxname="detail" jsxwidth="100%" jsxheight="100%" jsxdisplay="none" jsxvisibility=""></strings>
+              <strings jsxname="detail" jsxwidth="100%" jsxheight="100%" jsxdisplay="none" jsxvisibility="visible"></strings>
               <dynamics jsxbgcolor="@Solid Medium"></dynamics>
               <object type="jsx3.gui.Splitter">
Index: cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/appCanvas.xml
===================================================================
--- cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/appCanvas.xml	(revision 5273)
+++ cats/ISOcat/trunk/mod-ISOcat-interface-gi/interface/JSXAPPS/ISOcat/components/appCanvas.xml	(revision 5276)
@@ -17,5 +17,5 @@
         <object type="jsx3.gui.LayoutGrid">
           <variants jsxrepeat="2" jsxsizearray="['50','*']" jsxrelativeposition="0" jsxleft="0" jsxtop="0" jsxoverflow="2" jsxbestguess="1" jsxorientation="0"></variants>
-          <strings jsxname="layout (--)" jsxwidth="100%" jsxheight="100%" jsxrows="26,*"></strings>
+          <strings jsxname="layout (--)" jsxwidth="100%" jsxheight="100%" jsxrows="28px,*"></strings>
           <object type="jsx3.gui.Block">
             <variants jsxoverflow="2"></variants>
@@ -36,9 +36,4 @@
               </object>
               <object type="jsx3.gui.Menu">
-                <variants></variants>
-                <strings jsxname="viewMenu" jsxtip="Switch to another candidate interface." jsxtext="view" jsxxml="&lt;data jsxid=&quot;jsxroot&quot;&gt;  &lt;record jsxid=&quot;1&quot; jsxtext=&quot;Explorer&quot; jsxgroupname=&quot;view&quot; jsxselected=&quot;1&quot;/&gt;  &lt;record jsxid=&quot;2&quot; jsxtext=&quot;Desktop&quot; jsxgroupname=&quot;view&quot; jsxselected=&quot;0&quot;/&gt;  &lt;record jsxid=&quot;3&quot; jsxtext=&quot;Tabbook&quot; jsxgroupname=&quot;view&quot; jsxselected=&quot;0&quot;/&gt;  &lt;/data&gt;" jsximage="http://isocat:8080/Tango/16x16/apps/preferences-system-windows.png" jsxdisplay="none"></strings>
-                <events jsxexecute="this.selectItem(strRECORDID,true);org.isocat.activateView(objRECORD.getAttribute(&quot;jsxtext&quot;));"></events>
-              </object>
-              <object type="jsx3.gui.Menu">
                 <variants jsxxmlasync="0"></variants>
                 <strings jsxname="helpMenu" jsxtip="menu" jsxxmlurl="xml/help.xml"></strings>
@@ -48,5 +43,5 @@
           </object>
           <object type="jsx3.gui.Block">
-            <variants jsxoverflow="1"></variants>
+            <variants jsxoverflow="2"></variants>
             <strings jsxname="desktop" jsxwidth="100%" jsxheight="100%" jsxrelativeposition="1"></strings>
             <object type="jsx3.gui.Splitter">
@@ -55,5 +50,5 @@
               <events jsxafterresize=""></events>
               <object type="jsx3.gui.Block">
-                <variants jsxoverflow="1"></variants>
+                <variants jsxoverflow="2"></variants>
                 <strings jsxname="top" jsxwidth="100%" jsxheight="100%" jsxbgcolor="white"></strings>
                 <dynamics jsxborder="@Inset"></dynamics>
@@ -61,5 +56,5 @@
               </object>
               <object type="jsx3.gui.Block">
-                <variants jsxoverflow="1"></variants>
+                <variants jsxoverflow="2"></variants>
                 <strings jsxname="bottom" jsxwidth="100%" jsxheight="100%" jsxbgcolor="white"></strings>
                 <dynamics jsxborder="@Inset"></dynamics>