Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/Protocol.txt
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/Protocol.txt	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/Protocol.txt	(revision 5312)
@@ -11,5 +11,5 @@
        A virtual collection is represented in an internal XML format, which is
        defined by the W3C XML schema "VirtualCollection.xsd" found in the
-       "src/main/resources" directory.
+       "src/resources/META-INF" directory.
        
     b) The VCR relies on various HTTP headers:
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/pom.xml
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/pom.xml	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/pom.xml	(revision 5312)
@@ -112,4 +112,22 @@
           <target>${maven.compiler.target}</target>
           <compilerArgument>-proc:none</compilerArgument>
+        </configuration>
+      </plugin>
+
+      <plugin>
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-war-plugin</artifactId>
+        <version>2.1.1</version>
+        <configuration>
+          <webResources>
+            <!-- additional web resources: also copy schemas to web-app -->
+            <resource>
+              <directory>src/main/resources/META-INF</directory>
+              <targetPath>schema</targetPath>
+              <includes>
+                <include>*.xsd</include>
+              </includes>
+            </resource>
+          </webResources>
         </configuration>
       </plugin>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/VirtualCollectionMarshaller.java
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/VirtualCollectionMarshaller.java	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/VirtualCollectionMarshaller.java	(revision 5312)
@@ -64,5 +64,5 @@
             URL url = VirtualCollectionMarshaller.class
                     .getClassLoader()
-                    .getResource("VirtualCollection.xsd");
+                    .getResource("META-INF/VirtualCollection.xsd");
             if (url == null) {
                 throw new NullPointerException("schema not found!");
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.java
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.java	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/Application.java	(revision 5312)
@@ -51,4 +51,6 @@
             getMarkupSettings().setStripComments(true);
         }
+        mountBookmarkablePage("/login",
+                LoginPage.class);
         mountBookmarkablePage("/public",
                 BrowsePublicCollectionsPage.class);
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/ApplicationSession.java
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/ApplicationSession.java	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/ApplicationSession.java	(revision 5312)
@@ -44,9 +44,5 @@
     @Override
     public boolean authenticate(String username, String password) {
-        if (username != null) {
-            replaceSession();
-            return true;
-        }
-        return false;
+        return username != null;
     }
 
Index: rtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/resources/VirtualCollection.xsd
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/resources/VirtualCollection.xsd	(revision 5311)
+++ 	(revision )
@@ -1,142 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
-  elementFormDefault="unqualified">
-
-  <xs:element name="VirtualCollections">
-    <xs:complexType>
-      <xs:sequence>
-        <xs:element ref="VirtualCollection" minOccurs="0" maxOccurs="unbounded"/>
-      </xs:sequence>
-      <xs:attribute name="totalCount" type="xs:integer"/>
-      <xs:attribute name="offset" type="xs:integer"/>
-      <xs:attribute name="result">
-        <xs:simpleType>
-          <xs:restriction base="xs:string">
-            <xs:enumeration value="full"/>
-            <xs:enumeration value="partial"/>
-          </xs:restriction>
-        </xs:simpleType>
-      </xs:attribute>
-    </xs:complexType>
-  </xs:element>
-
-  <xs:element name="VirtualCollection">
-    <xs:complexType>
-      <xs:sequence>
-        <xs:element name="Type">
-          <xs:simpleType>
-            <xs:restriction base="xs:string">
-              <xs:enumeration value="extensional"/>
-              <xs:enumeration value="intensional"/>
-            </xs:restriction>
-          </xs:simpleType>
-        </xs:element>
-        <xs:element name="Name" type="xs:string"/>
-        <xs:element name="Description" type="xs:string" minOccurs="0"/>
-        <xs:element name="CreationDate" type="xs:date" minOccurs="0"/>
-        <xs:element name="Creators" minOccurs="0">
-          <xs:complexType>
-            <xs:sequence>
-              <xs:element name="Creator" minOccurs="1" maxOccurs="unbounded">
-                <xs:complexType>
-                    <xs:sequence>
-                      <xs:element name="Person" type="xs:string"/>
-                      <xs:element name="Address" type="xs:string" minOccurs="0"/>
-                      <xs:element name="Email" type="xs:string" minOccurs="0"/>
-                      <xs:element name="Organisation" type="xs:string" minOccurs="0"/>
-                      <xs:element name="Telephone" type="xs:string" minOccurs="0" />
-                      <xs:element name="Website" type="xs:anyURI" minOccurs="0" />
-                      <xs:element name="Role" type="xs:string" minOccurs="0" />
-                    </xs:sequence>
-                </xs:complexType>
-              </xs:element>
-            </xs:sequence>
-          </xs:complexType>
-        </xs:element>
-        <xs:element name="Purpose" minOccurs="0">
-          <xs:simpleType>
-            <xs:restriction base="xs:string">
-              <xs:enumeration value="research"/>
-              <xs:enumeration value="reference"/>
-              <xs:enumeration value="sample"/>
-              <xs:enumeration value="future-use"/>
-              <!-- to be extended -->
-            </xs:restriction>
-          </xs:simpleType>
-        </xs:element>
-        <xs:element name="Reproducibility" minOccurs="0">
-          <xs:simpleType>
-            <xs:restriction base="xs:string">
-              <xs:enumeration value="intended"/>
-              <xs:enumeration value="fluctuating"/>
-              <xs:enumeration value="untended"/>
-            </xs:restriction>
-          </xs:simpleType>
-        </xs:element>
-        <xs:element name="ReproducibilityNotice" type="xs:string" minOccurs="0" />
-        <xs:element name="Keywords" minOccurs="0">
-          <xs:complexType>
-        	<xs:sequence>
-        	  <xs:element name="Keyword" type="xs:string" minOccurs="1" maxOccurs="unbounded"/>
-        	</xs:sequence>
-          </xs:complexType>
-        </xs:element>
-        <xs:element name="Resources" minOccurs="0">
-          <xs:complexType>
-            <xs:sequence>
-              <xs:element name="Resource" minOccurs="1" maxOccurs="unbounded">
-                <xs:complexType>
-                  <xs:sequence>
-                    <xs:element name="ResourceType">
-                      <xs:simpleType>
-                        <xs:restriction base="xs:string">
-                          <xs:enumeration value="Metadata"/>
-                          <xs:enumeration value="Resource"/>
-                        </xs:restriction>
-                      </xs:simpleType>
-                    </xs:element>
-                    <xs:element name="ResourceRef">
-                      <xs:simpleType>
-                        <xs:restriction base="xs:anyURI"/>
-                      </xs:simpleType>
-                    </xs:element>
-                  </xs:sequence>
-                </xs:complexType>
-              </xs:element>
-            </xs:sequence>
-          </xs:complexType>
-        </xs:element>
-        <xs:element name="GeneratedBy" minOccurs="0">
-          <xs:complexType>
-            <xs:sequence>
-              <xs:element name="Description" type="xs:string"/>
-              <xs:element name="URI" type="xs:anyURI" minOccurs="0"/>
-              <xs:element name="Query" minOccurs="0">
-                <xs:complexType>
-                  <xs:simpleContent>
-                    <xs:extension base="xs:string">
-                      <xs:attribute name="profile" type="xs:string" use="required"/>
-                    </xs:extension>
-                  </xs:simpleContent>
-                </xs:complexType>
-              </xs:element>
-            </xs:sequence>
-          </xs:complexType>
-        </xs:element>
-      </xs:sequence>
-      <xs:attribute name="id" type="xs:long" use="optional" />
-      <xs:attribute name="persistentId" type="xs:string" use="optional" />
-      <xs:attribute name="state" use="optional">
-        <xs:simpleType>
-          <xs:restriction base="xs:string">
-            <xs:enumeration value="private" />
-            <xs:enumeration value="public-pending" />
-            <xs:enumeration value="public" />
-            <xs:enumeration value="deleted" />
-            <xs:enumeration value="dead" />
-          </xs:restriction>
-        </xs:simpleType>
-      </xs:attribute>
-    </xs:complexType>
-  </xs:element>
-</xs:schema>
Index: rtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/META-INF/persistence.xml
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/META-INF/persistence.xml	(revision 5311)
+++ 	(revision )
@@ -1,24 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<persistence xmlns="http://java.sun.com/xml/ns/persistence"
-	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-	xsi:schemaLocation="http://java.sun.com/xml/ns/persistence http://java.sun.com/xml/ns/persistence/persistence_2_0.xsd"
-	version="2.0">
-	<persistence-unit name="VirtualCollectionStore"
-		transaction-type="RESOURCE_LOCAL">
-        <provider>org.hibernate.ejb.HibernatePersistence</provider>
-        <jta-data-source>java:comp/env/jdbc/VirtualCollectionStore</jta-data-source>
-        <class>eu.clarin.cmdi.virtualcollectionregistry.model.User</class>
-        <class>eu.clarin.cmdi.virtualcollectionregistry.model.VirtualCollection</class>
-        <class>eu.clarin.cmdi.virtualcollectionregistry.model.Creator</class>
-        <class>eu.clarin.cmdi.virtualcollectionregistry.model.Resource</class>
-        <class>eu.clarin.cmdi.virtualcollectionregistry.model.PersistentIdentifier</class>
-        <validation-mode>NONE</validation-mode>
-        <properties>
-			<property name="hibernate.dialect" value="org.hibernate.dialect.MySQL5InnoDBDialect" />
-			<property name="hibernate.max_fetch_depth" value="3" />
-			<property name="hibernate.hbm2ddl.auto" value="update" />
-			<property name="hibernate.show_sql" value="false" />
-			<property name="hibernate.format_sql" value="false" />
-        </properties>
-    </persistence-unit>
-</persistence>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/WEB-INF/web.xml
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/WEB-INF/web.xml	(revision 5311)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/WEB-INF/web.xml	(revision 5312)
@@ -116,5 +116,5 @@
             <web-resource-name>VirtualCollectionRegistryApplication</web-resource-name>
             <description></description>
-            <url-pattern>/app/*</url-pattern>
+            <url-pattern>/app/login</url-pattern>
             <http-method>GET</http-method>
         </web-resource-collection>